# terraform-module-aws-rds

Terraform module that helps you create a RDS instance.

This module can create:

- 1 RDS cluster with n RDS cluster endpoint OR 1 RDS DB instance
- 1 Option Group (if not RDS cluster)
- 1 Parameter Group or cluster Parameter Group
- 1 DB Subnet Group
- 1 KMS key per service, including DB, performance insight, Secret Manager and SSM Parameter
- 1 Security Group allowing source Security Groups and/or CIDR range
- Export RDS endpoint, RDS reader endpoint, RDS port, master username, master password, database name and character set name on SSM parameters. Master username and master password are stored as SecureString, encrypted by a KMS key.

## Limitations

- This module doesn't support RDS global cluster creation. There is an issue with deletion:

  ```
    error deleting RDS Cluster (nsu6suhxtftest-00001): InvalidDBClusterStateFault: This cluster is a part of a global cluster, please remove it from globalcluster first
  ```

<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| terraform | >= 1.9 |
| aws | >= 5 |
| random | >= 3 |
| time | >= 0 |

## Providers

| Name | Version |
|------|---------|
| aws | >= 5 |
| random | >= 3 |
| time | >= 0 |

## Modules

| Name | Source | Version |
|------|--------|---------|
| kms | gitlab.com/wild-beavers/module-aws-kms/aws | ~> 2 |
| secret | gitlab.com/wild-beavers/module-aws-secret-manager/aws | ~> 3 |
| ssm | gitlab.com/wild-beavers/module-aws-ssm-parameters/aws | ~> 6 |

## Resources

| Name | Type |
|------|------|
| [aws_db_instance.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/db_instance) | resource |
| [aws_db_option_group.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/db_option_group) | resource |
| [aws_db_parameter_group.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/db_parameter_group) | resource |
| [aws_db_subnet_group.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/db_subnet_group) | resource |
| [aws_rds_cluster.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/rds_cluster) | resource |
| [aws_rds_cluster_instance.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/rds_cluster_instance) | resource |
| [aws_rds_cluster_parameter_group.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/rds_cluster_parameter_group) | resource |
| [aws_security_group.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/security_group) | resource |
| [aws_security_group_rule.this_in_cidr](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/security_group_rule) | resource |
| [aws_security_group_rule.this_in_sg](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/security_group_rule) | resource |
| [random_id.final_snapshot](https://registry.terraform.io/providers/hashicorp/random/latest/docs/resources/id) | resource |
| [time_sleep.wait_secret_manager_password](https://registry.terraform.io/providers/hashicorp/time/latest/docs/resources/sleep) | resource |
| [aws_secretsmanager_secret_version.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/secretsmanager_secret_version) | data source |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| create\_ssm\_parameters | Create SSM parameters related to database information | `bool` | `false` | no |
| current\_account\_id | The account where this module is run. | `string` | `""` | no |
| current\_region | The region where this module is run. | `string` | `""` | no |
| database | Options of the the database.<br/>Depending on `cluster`, option may or may not be relevant, so be careful when using them.<br/>A non-relevant option will likely be silent.<br/>Shared options (between cluster and single DB) are first, then cluster, then single DB.<br/><br/>- cluster (optional, bool, false): Makes database HA using a cluster.<br/>- size    (optional, number, 0):   Size of the cluster. Only useful for Aurora-based clusters.<br/><br/>- allocated\_storage  (required, number):  Amount of storage in gibibytes (GiB) to allocate to DB instance(s).<br/>- engine             (required, string):  Name of the database engine to be used for this DB cluster or DB instance.<br/>- instance\_class     (required, string):  Instance type of the RDS instance.<br/><br/>- allow\_major\_version\_upgrade           (optional, bool, false):        Indicates that major version upgrades are allowed.<br/>- apply\_immediately                     (optional, bool, false):        Whether any database modifications are applied immediately, or during the next maintenance window.<br/>- auto\_minor\_version\_upgrade            (optional, bool, true):         Indicates that minor engine upgrades will be applied automatically to the DB instance(s) during the maintenance window.<br/>- availability\_zones                    (optional, list(string)):       List of EC2 Availability Zones for the DB cluster storage where DB cluster instances can be created. RDS automatically assigns 3 AZs if less than 3 AZs are configured, which will show as a difference requiring resource recreation next Terraform apply. For a single DB instance, only the first AZ of the list will be used.<br/>- backup\_retention\_period               (optional, number, 1):          The days to retain backups for. Must be between 0 and 35.<br/>- backup\_window                         (optional, string):             The daily time range (in UTC) during which automated backups are created if they are enabled. Example: "09:46-10:16". Must not overlap with `maintenance_window`.<br/>- ca\_cert\_identifier                    (optional, string):             Identifier of the CA certificate for the DB instance(s).<br/>- copy\_tags\_to\_snapshot                 (optional, bool, false):        Copy all DB instance(s) tags to snapshots.<br/>- cluster\_identifier                    (optional, string):             Cluster identifier.<br/>- custom\_iam\_instance\_profile           (optional, string):             Instance profile associated with the underlying Amazon EC2 instance of an RDS Custom DB instance.<br/>- db\_name                               (optional, string):             Name of the database to create when the DB instance(s) is/are created. If this parameter is not specified, no database is created in the DB instance(s).<br/>- delete\_automated\_bsackups             (optional, bool, true):         Whether to remove automated backups immediately after the DB instance(s) is/are deleted.<br/>- deletion\_protection                   (optional, bool, false):        Whether to protect DB instance(s) against accidental deletions. The database can’t be deleted when this value is set to `true`.<br/>- domain                                (optional, string):             ID of the Directory Service Active Directory domain to create the instance(s) in. Conflicts with `domain_fqdn`, `domain_ou`, `domain_auth_secret_arn` and a `domain_dns_ips`.<br/>- domain\_iam\_role\_name                  (optional, string):             Name of the IAM role to be used when making API calls to the Directory Service<br/>- enabled\_cloudwatch\_logs\_exports       (optional, set(string)):        Set of log types to enable for exporting to CloudWatch logs. If omitted, no logs will be exported. The following log types are supported: `audit`, `error`, `general`, `slowquery`, `postgresql`.<br/>- engine\_version                        (optional, string):             Engine version to use. If `auto_minor_version_upgrade` is enabled, you can provide a prefix of the version such as "8.0" (for "8.0.36").<br/>- engine\_lifecycle\_support              (optional, string):             Life cycle type for DB instance(s). This setting applies only to MySQL or PostgreSQL and their Aurora variants. Valid values are `open-source-rds-extended-support`, `open-source-rds-extended-support-disabled`. Default value is `open-source-rds-extended-support`.<br/>- final\_snapshot\_identifier             (optional, string):             Name of the final DB snapshot when DB instance(s) is/are deleted. If omitted, no final snapshot will be made.<br/>- iam\_database\_authentication\_enabled   (optional, bool, false):        Whether mappings of AWS IAM accounts to database accounts is enabled.<br/>- identifier                            (optional, string):             Name of the RDS instance (or cluster), if omitted, Terraform will assign a random, unique identifier.<br/>- iops                                  (optional, number):             Amount of provisioned IOPS. Setting this implies a storage\_type of "io1" or "io2". Can only be set when storage\_type is "io1", "io2 or "gp3". Cannot be specified for gp3 storage if the allocated\_storage value is below a per-engine threshold.<br/>- maintenance\_window                    (optional, string):             Weekly time range during which system maintenance can occur, in (UTC) e.g., wed:04:00-wed:04:30<br/>- manage\_master\_user\_password           (optional, bool, false):        Allow RDS to manage the master user password in Secrets Manager. Cannot be set if `password` is provided.<br/>- username                              (optional, string):             Username for the master DB user.<br/>- password                              (optional, string):             Password for the master DB user. Note that this may show up in logs, and it will be stored in the state file.<br/>- monitoring\_interval                   (optional, number):             Interval, in seconds, between points when Enhanced Monitoring metrics are collected for the DB instance. To disable collecting Enhanced Monitoring metrics, specify 0. The default is 0. Valid Values: 0, 1, 5, 10, 15, 30, 60.<br/>- monitoring\_role\_arn                   (optional, string):             ARN for the IAM role that permits RDS to send enhanced monitoring metrics to CloudWatch Logs.<br/>- network\_type                          (optional, string):             Network type of the DB instance. Valid values: IPV4, DUAL.<br/>- performance\_insights\_enabled          (optional, bool, false):        Whether Performance Insights are enabled.<br/>- performance\_insights\_retention\_period (optional, number):             Amount of time in days to retain Performance Insights data. Valid values are 7, 731 (2 years) or a multiple of 31. When specifying `performance_insights_retention_period`, `performance_insights_enabled` needs to be set to true.<br/>- port                                  (optional, number):             Port on which the DB accepts connections.<br/>- publicly\_accessible                   (optional, bool, false):        Control if instance is publicly accessible.<br/>- restore\_to\_point\_in\_time              (optional, object):<br/>   - source\_cluster\_identifier                (optional, string):      Identifier of the source database cluster from which to restore. When restoring from a cluster in another AWS account, the identifier is the ARN of that cluster.<br/>   - source\_cluster\_resource\_id               (optional, string):      Cluster resource ID of the source database cluster from which to restore. To be used for restoring a deleted cluster in the same account which still has a retained automatic backup available.<br/>   - restore\_type                             (optional, string):      Type of restore to be performed. Valid options are full-copy (default) and copy-on-write.<br/>   - use\_latest\_restorable\_time               (optional, bool, false): Whether to restore the database cluster to the latest restorable backup time. Defaults to false. Conflicts with `restore_to_time`.<br/>   - source\_db\_instance\_identifier            (optional, string):      Identifier of the source DB instance from which to restore. Must match the identifier of an existing DB instance. Required if source\_db\_instance\_automated\_backups\_arn or source\_dbi\_resource\_id is not specified.<br/>   - source\_db\_instance\_automated\_backups\_arn (optional, string):      ARN of the automated backup from which to restore. Required if source\_db\_instance\_identifier or source\_dbi\_resource\_id is not specified.<br/>   - restore\_time                             (optional, string):      Date and time in UTC format to restore the database cluster to. Conflicts with `use_latest_restorable_time`.<br/>- skip\_final\_snapshot                   (optional, bool, false):        Whether a final DB snapshot is created before the DB instance is deleted. If "true", no DBSnapshot is created. If "false", a DB snapshot is created before the DB instance is deleted, using the value from `final_snapshot_identifier`. Enabling this option also allows for easy engine updates, as final snapshots can be used to restore the database automatically.<br/>- snapshot\_identifier                   (optional, string):             Whether to create this database from a snapshot. This correlates to the snapshot ID you’d find in the RDS console, e.g: rds:production-2015-06-26-06-05.<br/>- storage\_encrypted                     (optional, bool):               Whether the DB instance is encrypted. Note that if you are creating a cross-region read replica this field is ignored and you should instead declare `var.kms_keys.db` or `var.kms_key_id`.<br/>- storage\_type                          (optional, string):             One of "standard" (magnetic), "gp2" (general purpose SSD), "gp3" (general purpose SSD that needs iops independently) "io1" (provisioned IOPS SSD) or "io2" (block express storage provisioned IOPS SSD). The default is "io1" if iops is specified, "gp2" if not.<br/>- tags                                  (optional, map(string)):        Map of tags to assign to the database. Will be merged with `var.tags`.<br/><br/>- domain\_ou                 (optional, string):       Self managed Active Directory organizational unit for your DB instance to join. Conflicts with domain and domain\_iam\_role\_name.<br/>- dedicated\_log\_volume      (optional, bool):         Use a dedicated log volume (DLV) for the DB instance. Requires Provisioned IOPS.<br/>- character\_set\_name        (optional, string):       The character set name to use for DB encoding in Oracle and Microsoft SQL instances (collation). This can’t be changed.<br/>- backup\_target             (optional, string):       Specifies where automated backups and manual snapshots are stored. Possible values are region (default) and outposts.<br/>- blue\_green\_update         (optional, bool, false):  Enables low-downtime updates using RDS Blue/Green deployments.<br/>- domain\_auth\_secret\_arn    (optional, string):       ARN for the Secrets Manager secret with the self managed Active Directory credentials for the user joining the domain. Conflicts with `domain` and `domain_iam_role_name`.<br/>- domain\_dns\_ips            (optional, list(string)): The IPv4 DNS IP addresses of your primary and secondary self managed Active Directory domain controllers. Two IP addresses must be provided. If there isn’t a secondary domain controller, use the IP address of the primary domain controller for both entries in the list. Conflicts with `domain` and `domain_iam_role_name`.<br/>- domain\_fqdn               (optional, string):       Fully qualified domain name (FQDN) of the self managed Active Directory domain. Conflicts with `domain` and `domain_iam_role_name`.<br/>- license\_model             (optional, string):       License model information for this DB instance.<br/>- max\_allocated\_storage     (optional, number):       When configured, the upper limit to which Amazon RDS can automatically scale the storage of the DB instance. Configuring this will automatically ignore differences to allocated\_storage. Must be greater than or equal to allocated\_storage or 0 to disable Storage Autoscaling.<br/>- multi\_az                  (optional, bool, false):  Specifies if the RDS instance is multi-AZ.<br/>- nchar\_character\_set\_name  (optional, string):       National character set is used in the NCHAR, NVARCHAR2, and NCLOB data types for Oracle instances. This can’t be changed.<br/>- replica\_mode              (optional, bool):         Whether the replica is in either mounted or open-read-only mode. This attribute is only supported by Oracle instances. Oracle replicas operate in open-read-only mode unless otherwise specified.<br/>- replicate\_source\_db       (optional, string):       Specifies that this resource is a Replicate database, and to use this value as the source database. This correlates to the identifier of another Amazon RDS Database to replicate (if replicating within a single region) or ARN of the Amazon RDS Database to replicate (if replicating cross-region). Note that if you are creating a cross-region replica of an encrypted database you will also need to specify a KMS key.<br/>- upgrade\_storage\_config    (optional, bool):         Whether to upgrade the storage file system configuration on the read replica. Can only be set with replicate\_source\_db.<br/>- s3\_import                 (optional, object):       Restore from a Percona Xtrabackup in S3:<br/>   - bucket\_name           (required, string): Bucket name where the backup is stored<br/>   - ingestion\_role        (required, string): Role applied to load the data.<br/>   - source\_engine         (required, string): Source engine for the backup<br/>   - source\_engine\_version (required, string): Version of the source engine used to make the backup<br/>   - bucket\_prefix         (optional, string): Can be blank, but is the path to your backup<br/>- storage\_throughput        (optional, string):       Storage throughput value for the DB instance. Can only be set when storage\_type is "gp3". Cannot be specified if the allocated\_storage value is below a per-engine threshold.<br/>- timezone                  (optional, string):       Time zone of the DB instance. timezone is currently only supported by Microsoft SQL Server. The timezone can only be set on creation.<br/>- customer\_owned\_ip\_enabled (optional, bool):         Whether to enable a customer-owned IP address (CoIP) for an RDS on Outposts DB instance.<br/><br/>- db\_system\_id                  (optional, string):       For use with RDS Custom.<br/>- backtrack\_window              (optional, number):       Target backtrack window, in seconds. Only available for aurora and aurora-mysql engines currently. To disable backtracking, set this value to 0. Defaults to 0. Must be between 0 and 259200 (72 hours)<br/>- enable\_http\_endpoint          (optional, string):       Enable HTTP endpoint (data API). Only valid for some combinations of engine\_mode, engine and engine\_version and only available in some regions. This option also does not work with any of these options specified: snapshot\_identifier, replication\_source\_identifier, s3\_import.<br/>- enable\_local\_write\_forwarding (optional, bool):         Whether read replicas can forward write operations to the writer DB instance in the DB cluster. By default, write operations aren’t allowed on reader DB instances. NOTE: Local write forwarding requires Aurora MySQL version 3.04 or higher.<br/>- engine\_mode                   (optional, string):       Database engine mode. Valid values: global (only valid for Aurora MySQL 1.21 and earlier), parallelquery, provisioned, serverless. Defaults to: provisioned.<br/>- iam\_roles                     (optional, list(string)): List of ARNs for the IAM roles to associate to the RDS Cluster.<br/>- replication\_source\_identifier (optional, string):       ARN of a source DB cluster or DB instance if this DB cluster is to be created as a Read Replica. If DB Cluster is part of a Global Cluster, use the lifecycle configuration block ignore\_changes argument to prevent Terraform from showing differences for this argument instead of configuring this value.<br/>- promotion\_tier                (optional, number):       Failover Priority setting on instance level. The reader who has lower tier has higher priority to get promoted to writer.<br/>- scaling\_configuration         (optional, object):       Nested attribute with scaling properties. Only valid when `engine_mode` is set to `serverless`. More details below.<br/>   - auto\_pause               (optional, bool, true): Whether to enable automatic pause. A DB cluster can be paused only when it’s idle (it has no connections). If a DB cluster is paused for more than seven days, the DB cluster might be backed up with a snapshot. In this case, the DB cluster is restored when there is a request to connect to it.<br/>   - max\_capacity             (optional, number):     Maximum capacity for an Aurora DB cluster in serverless DB engine mode. The maximum capacity must be greater than or equal to the minimum capacity. Valid Aurora MySQL capacity values are 1, 2, 4, 8, 16, 32, 64, 128, 256. Valid Aurora PostgreSQL capacity values are (2, 4, 8, 16, 32, 64, 192, and 384). Defaults to 16.<br/>   - min\_capacity             (optional, number):     Minimum capacity for an Aurora DB cluster in serverless DB engine mode. The minimum capacity must be lesser than or equal to the maximum capacity. Valid Aurora MySQL capacity values are 1, 2, 4, 8, 16, 32, 64, 128, 256. Valid Aurora PostgreSQL capacity values are (2, 4, 8, 16, 32, 64, 192, and 384). Defaults to 1.<br/>   - seconds\_before\_timeout   (optional, number):     Amount of time, in seconds, that Aurora Serverless v1 tries to find a scaling point to perform seamless scaling before enforcing the timeout action. Valid values are 60 through 600. Defaults to 300.<br/>   - seconds\_until\_auto\_pause (optional, number):     Time, in seconds, before an Aurora DB cluster in serverless mode is paused. Valid values are 300 through 86400. Defaults to 300.<br/>   - timeout\_action           (optional, string):     Action to take when the timeout is reached. Valid values: ForceApplyCapacityChange, RollbackCapacityChange. Defaults to RollbackCapacityChange.<br/>- serverlessv2\_scaling\_configuration (optional, object): Nested attribute with scaling properties for ServerlessV2. Only valid when engine\_mode is set to provisioned. More details below.<br/>   - max\_capacity (required, number): Maximum capacity for an Aurora DB cluster in provisioned DB engine mode. The maximum capacity must be greater than or equal to the minimum capacity. Valid capacity values are in a range of 0.5 up to 128 in steps of 0.5.<br/>   - min\_capacity (required, number): Minimum capacity for an Aurora DB cluster in provisioned DB engine mode. The minimum capacity must be lesser than or equal to the maximum capacity. Valid capacity values are in a range of 0.5 up to 128 in steps of 0.5.<br/>- source\_region (optional, string): The source region for an encrypted replica DB cluster. | <pre>object({<br/>    cluster = optional(bool, false)<br/>    size    = optional(number, 2)<br/><br/>    allocated_storage = number<br/>    engine            = string<br/>    instance_class    = string<br/><br/>    allow_major_version_upgrade           = optional(bool, false)<br/>    apply_immediately                     = optional(bool, false)<br/>    auto_minor_version_upgrade            = optional(bool, true)<br/>    availability_zones                    = optional(list(string), [])<br/>    backup_retention_period               = optional(number, 1)<br/>    ca_cert_identifier                    = optional(string)<br/>    cluster_identifier                    = optional(string)<br/>    copy_tags_to_snapshot                 = optional(bool, false)<br/>    custom_iam_instance_profile           = optional(string)<br/>    db_name                               = optional(string)<br/>    delete_automated_backups              = optional(bool, true)<br/>    deletion_protection                   = optional(bool, false)<br/>    domain                                = optional(string)<br/>    domain_iam_role_name                  = optional(string)<br/>    enabled_cloudwatch_logs_exports       = optional(set(string))<br/>    engine_version                        = optional(string)<br/>    engine_lifecycle_support              = optional(string)<br/>    final_snapshot_identifier             = optional(string)<br/>    iam_database_authentication_enabled   = optional(bool, false)<br/>    identifier                            = optional(string)<br/>    iops                                  = optional(number)<br/>    maintenance_window                    = optional(string)<br/>    manage_master_user_password           = optional(bool, false)<br/>    username                              = optional(string)<br/>    password                              = optional(string)<br/>    monitoring_interval                   = optional(number)<br/>    monitoring_role_arn                   = optional(string)<br/>    network_type                          = optional(string)<br/>    performance_insights_enabled          = optional(bool, false)<br/>    performance_insights_retention_period = optional(number)<br/>    port                                  = optional(number)<br/>    publicly_accessible                   = optional(bool, false)<br/>    restore_to_point_in_time = optional(object({<br/>      source_cluster_resource_id               = optional(string)<br/>      source_cluster_identifier                = optional(string)<br/>      restore_type                             = optional(string)<br/>      use_latest_restorable_time               = optional(bool, false)<br/>      source_db_instance_identifier            = optional(string)<br/>      source_db_instance_automated_backups_arn = optional(string)<br/>      restore_time                             = optional(string)<br/>    }))<br/>    skip_final_snapshot = optional(bool, false)<br/>    snapshot_identifier = optional(string)<br/>    storage_encrypted   = optional(bool)<br/>    storage_type        = optional(string)<br/>    tags                = optional(map(string), {})<br/><br/>    domain_ou                = optional(string)<br/>    dedicated_log_volume     = optional(bool)<br/>    character_set_name       = optional(string)<br/>    backup_target            = optional(string)<br/>    backup_window            = optional(string)<br/>    blue_green_update        = optional(bool, false)<br/>    domain_auth_secret_arn   = optional(string)<br/>    domain_dns_ips           = optional(list(string))<br/>    domain_fqdn              = optional(string)<br/>    license_model            = optional(string)<br/>    max_allocated_storage    = optional(number)<br/>    multi_az                 = optional(bool, false)<br/>    nchar_character_set_name = optional(string)<br/>    replica_mode             = optional(bool)<br/>    replicate_source_db      = optional(string)<br/>    upgrade_storage_config   = optional(bool)<br/>    s3_import = optional(object({<br/>      bucket_name           = string<br/>      ingestion_role        = string<br/>      source_engine         = string<br/>      source_engine_version = string<br/>      bucket_prefix         = optional(string)<br/>    }))<br/>    storage_throughput        = optional(string)<br/>    timezone                  = optional(string)<br/>    customer_owned_ip_enabled = optional(bool)<br/><br/>    db_system_id                  = optional(string)<br/>    backtrack_window              = optional(number)<br/>    enable_http_endpoint          = optional(string)<br/>    enable_local_write_forwarding = optional(bool)<br/>    engine_mode                   = optional(string)<br/>    iam_roles                     = optional(list(string))<br/>    replication_source_identifier = optional(string)<br/>    promotion_tier                = optional(number)<br/>    scaling_configuration = optional(object({<br/>      auto_pause               = optional(bool, true)<br/>      max_capacity             = optional(number)<br/>      min_capacity             = optional(number)<br/>      seconds_before_timeout   = optional(number)<br/>      seconds_until_auto_pause = optional(number)<br/>      timeout_action           = optional(string)<br/>    }))<br/>    serverlessv2_scaling_configuration = optional(object({<br/>      max_capacity = number<br/>      min_capacity = number<br/>    }))<br/>    source_region = optional(string)<br/>  })</pre> | `null` | no |
| db\_subnet\_group | Parameter Group to create.<br/>  - name         (required, string):             Name of the DB Subnet Group.<br/>  - subnet\_ids   (required, list(string), []):   VPC Subnet IDs to be used to create a new DB Subnet Group. If provided, a new DB Subnet Group will be created, otherwise an existing Subnet Group `var.db_subnet_group_name` will be used instead.<br/>  - description  (optional, string):             Description of the DB Subnet Group.<br/>  - tags         (optional, map(string), {}):    Tags to assign to the resource, will be merged with `var.tags`. | <pre>object({<br/>    name        = string<br/>    subnet_ids  = list(string)<br/>    description = optional(string, "")<br/>    tags        = optional(map(string), {})<br/>  })</pre> | `null` | no |
| db\_subnet\_group\_name | Name of existing database DB Subnet Group. Conflicts `var.db_subnet_group`. | `string` | `""` | no |
| kms\_iam\_policy\_entity\_arns | Restrict KMS keys access the given IAM entities (roles or users).<br/>Allowed keys (scopes) are `ro`, `rw`, `rwd`, `audit` or `full`, each specifying the expected level of access for entities within them.<br/>Wildcards are allowed. | `map(map(string))` | `{}` | no |
| kms\_iam\_policy\_restrict\_by\_account\_ids | Restrict KMS keys created by this module by the given account IDs. Internal policies will whitelist given list. If `null`, no restriction will be applied. Especially useful when IAM entities contains accounts wildcards. | `list(string)` | `[]` | no |
| kms\_iam\_policy\_restrict\_by\_regions | Restrict KMS keys created by this module by the given regions. Internal policies will whitelist given list. If `null`, no restriction will be applied. Especially useful when IAM entities contains region wildcards. | `list(string)` | `[]` | no |
| kms\_iam\_policy\_sid\_prefix | Use a prefix for all `Sid` of KMS keys policies - internal and external - created by this module. | `string` | `""` | no |
| kms\_iam\_policy\_source\_arns | Restrict access to the KMS keys to the given ARN sources.<br/>Allowed keys (scopes) are `ro`, `rw`, `rwd`, `audit` or `full`, each specifying the expected level of access for entities within them.<br/>Wildcards are allowed. | `map(map(string))` | `{}` | no |
| kms\_key\_id | ARN or ID (or alias) of the AWS KMS customer master key (CMK) to be used to encrypt all the database data. If you don’t specify this value or `var.kms_keys.db`, defaults to using the AWS account’s default RDS KMS key. | `string` | `""` | no |
| kms\_keys | Options of the KMS keys to create, for various resources in this module.<br/>Would you wish to reuse the same KMS key for multiple resources, use the `var.kms_***_kms_id` variables.<br/>Allowed keys are "db", "ssm\_parameter", "performance\_insight" or "secrets\_manager":<br/><br/>  - alias                   (required, string):                      KMS key alias; Display name of the KMS key. Omit the `alias/`.<br/>  - principal\_actions       (optional, map(list(string))):           List of read-only, read-write, read-write-delete, audit and full allowed IAM actions for the principals defined by "var.iam\_policy\_entity\_arns[key]" variable, or nobody, if variable value is undefined. The four expected keys are "ro", "rw", "rwd", "audit" and "full". If this is not provided, actions default to corresponding `var.iam_policy_external_actions_...`.<br/>  - policy\_json             (optional, string):                      Additional policy to attach to the KMS key, merged with a baseline internal policy.<br/>  - description             (optional, string, ""):                  Description of the key.<br/>  - rotation\_enabled        (optional, bool, true):                  Whether to automatically rotate the KMS key linked to the secrets.<br/>  - deletion\_window\_in\_days (optional, number, 7):                   The waiting period, specified in number of days. After the waiting period ends, AWS KMS deletes the KMS key. If you specify a value, it must be between `7` and `30`, inclusive. If you do not specify a value, it defaults to `7`.<br/>  - tags                    (optional, map(string)):                 Tags to be used by the KMS key of this module. | <pre>map(object({<br/>    alias                   = string<br/>    principal_actions       = optional(map(list(string)))<br/>    policy_json             = optional(string, null)<br/>    description             = optional(string, "")<br/>    rotation_enabled        = optional(bool, true)<br/>    deletion_window_in_days = optional(number, 7)<br/>    tags                    = optional(map(string), {})<br/>  }))</pre> | `{}` | no |
| kms\_performance\_insight\_key\_id | ARN or ID (or alias) of the AWS KMS customer master key (CMK) to be used to encrypt all the performance insight data. If you don’t specify this value or `var.kms_keys.performance_insight`, defaults to using the AWS account’s default RDS KMS key. | `string` | `""` | no |
| kms\_ssm\_parameter\_key\_id | ARN or ID (or alias) of the AWS KMS customer master key (CMK) to be used to encrypt all the SSM Parameters. If you don’t specify this value or `var.kms_keys.ssm_parameter`, defaults to using the AWS account’s default SSM KMS key. | `string` | `""` | no |
| kms\_tags | Tags to be shared with all KMS keys created by this module. | `map(string)` | `{}` | no |
| option\_group | Option Group to create:<br/>  - name                 (required, string):          Name of the Option Group.<br/>  - engine\_name          (required, string):          Name of the engine that this option group should be associated with.<br/>  - major\_engine\_version (required, string):          Major version of the engine that this option group should be associated with.<br/>  - description          (optional, string, dynamic): Description of the DB option group.<br/>  - skip\_destroy         (optional, bool, false):     Set to `true` if you do not wish the option group to be deleted at destroy time, and instead just remove the option group from the Terraform state.<br/>  - tags                 (optional, map(string), {}): Tags to assign to the resource, will be merged with `var.tags`. | <pre>object({<br/>    name                 = string<br/>    engine_name          = string<br/>    major_engine_version = string<br/>    description          = optional(string, null)<br/>    skip_destroy         = optional(bool, false)<br/>    tags                 = optional(map(string), {})<br/>  })</pre> | `null` | no |
| option\_group\_options | A list of options to apply to the Option Group:<br/>  - option\_name                    (required, string):       Name of the option setting (e.g. MEMCACHED).<br/>  - port                           (optional, number):       Port number of connection to specific option setting - like MEMCACHED. (e.g. 11211).<br/>  - version                        (optional, string):       Version of the option setting (e.g. 13.1.0.0).<br/>  - db\_security\_group\_memberships  (optional, list(string)): List of DB Security Groups for which the option is enabled.<br/>  - vpc\_security\_group\_memberships (optional, list(string)): List of VPC Security Groups for which the option is enabled.<br/>  - option\_settings                (required, list(map)):    List of map of option settings to apply:<br/>    - name  (required, string): Name of the setting.<br/>    - value (required, string): Value of the setting. | <pre>list(object({<br/>    option_name                    = string<br/>    port                           = optional(number)<br/>    version                        = optional(string)<br/>    db_security_group_memberships  = optional(list(string))<br/>    vpc_security_group_memberships = optional(list(string))<br/>    option_settings = list(object({<br/>      name  = string<br/>      value = string<br/>    }))<br/>  }))</pre> | `[]` | no |
| parameter\_group | Parameter Group to create.<br/>  - name         (required, string):          Name of the DB Parameter Group.<br/>  - family       (required, string):          The family of the DB parameter group.<br/>  - description  (optional, string, dynamic): Description of the DB parameter group.<br/>  - skip\_destroy (optional, bool, false):     Set to `true` if you do not wish the parameter group to be deleted at destroy time, and instead just remove the parameter group from the Terraform state.<br/>  - tags         (optional, map(string), {}): Tags to assign to the resource, will be merged with `var.tags`. | <pre>object({<br/>    name         = string<br/>    family       = string<br/>    description  = optional(string, null)<br/>    skip_destroy = optional(bool, false)<br/>    tags         = optional(map(string), {})<br/>  })</pre> | `null` | no |
| parameter\_group\_parameters | Parameter Groups Parameters to add:<br/>  - name         (required, string):       Name of the DB parameter.<br/>  - value        (required, string):       Value of the DB parameter.<br/>  - apply\_method (optional, string, null): "immediate" (default), or "pending-reboot". Some engines can’t apply some parameters without a reboot, and you will need to specify "pending-reboot" here. | <pre>list(object({<br/>    name         = string<br/>    value        = string<br/>    apply_method = optional(string, null)<br/>  }))</pre> | `[]` | no |
| replica\_enabled | Whether to replicate the resources of this module into the `aws.replica` region. | `bool` | `true` | no |
| replica\_region | The region where this module must replicate resources. | `string` | `""` | no |
| secret | Store the RDS username and password in a Secrets Manager Secret.<br/>Similar feature as `var.database.manage_master_user_password`.<br/>One may prefer this over `var.database.manage_master_user_password` to fine-grained the SecretsManager Secret characteristics like the KMS key, the JSON format, rotation lambda, or the resource-based policy for better security and convenience.<br/>Therefore, this variable conflicts with `var.database.manage_master_user_password`.<br/>  - name                               (optional, string, "database\_secret"): Name of the Secrets Manager Secret.<br/>  - description                        (optional, string, dynamic):           Description of the Secrets Manager Secret.<br/>  - use\_provided\_password              (optional, bool, true):                Store the secret provided in `var.database.password`. You might want to disable this to force the Secret Manager Secret to NOT contain the real database password, in the intention to immediate secret rotation. This is recommended to avoid storing secret in the state file, but require external automation or manual intervention.<br/>  - username\_key                       (optional, string, "username"):        Name of the JSON key containing the username of the RDS.<br/>  - password\_key                       (optional, string, "password"):        Name of the JSON key containing the password of the RDS.<br/>  - iam\_policy\_entity\_arns             (required, map(map(string)), {}):      Restrict access the given IAM entities (roles or users). Allowed keys (scopes) are `ro`, `rw`, `rwd`, `audit` or `full`, each specifying the expected level of access for entities within them. `full` is mandatory to avoid the secret being unmanageable.<br/>  - iam\_policy\_export\_actions          (optional, bool, false):               Whether to output IAM policies actions for the Secrets Manager Secret. A lightweight way to generate identity-based policies.<br/>  - iam\_policy\_identity\_export\_jsons   (optional, bool, false):               Whether to export identity-based IAM policies contents as JSON for the Secrets Manager Secret. Setting this to `true` do not create any policies.<br/>  - iam\_policy\_restrict\_by\_account\_ids (optional, list(string), []):          Restrict IAM Policy by the given account IDs. Resource-based Policy will whitelist given list. If empty, no restriction will be applied. Especially useful when IAM entities contains accounts wildcards.<br/>  - iam\_policy\_restrict\_by\_regions     (optional, list(string), []):          Restrict resource-based IAM Policy by the given regions. Resource-Based Policy will whitelist given list. If empty, no restriction will be applied. Especially useful when IAM entities contains region wildcards.<br/>  - iam\_policy\_sid\_prefix              (optional, string, ""):                Use a prefix for all `Sid` of all the policies created by the secret.<br/>  - iam\_policy\_source\_arns             (optional, map(map(string)), {}):      Restrict accesses to the given source ARNs. Wildcards are allowed. Keys are scope: `ro`, `rw`, `rwd`, `audit` or `full`, each specifying the expected level of access for entities defined within.<br/>  - iam\_policy\_source\_policy\_documents (optional, list(string), []):          List of JSON strings to be concatenated to the resource-based IAM Policy.<br/>  - kms\_key\_id                         (optional, string):                    KMS key ID (or alias) to use to store the Secret Managers Secret. Conflicts with `var.kms_keys.secrets_manager`. If neither this argument not `var.kms_keys.secrets_manager` are set, the default KMS for Secrets Manager will be used.<br/>  - kms\_key\_replica\_id                 (optional, string):                    KMS key replica ID (or replica alias) to use to store the replica of the secret. Conflicts with `var.kms_keys.secrets_manager`. If neither this argument not `var.kms_keys.secrets_manager` are set, the default KMS for Secrets Manager will be used.<br/>  - recovery\_window\_in\_days            (optional, number, 7):                 The number of days that AWS Secrets Manager waits before it can delete the secret. This value can be `0` to force deletion without recovery or range from `7` to `30` days.<br/>  - rotation\_automatically\_after\_days  (optional, number):                    Specifies the number of days between automatic scheduled rotations of the secret. Needs `rotation_lambda_arn`.<br/>  - rotation\_duration                  (optional, number, 24):                The length of the rotation window in hours. For example, `3` for a three hour window. Needs `rotation_lambda_arn`.<br/>  - rotation\_enabled                   (optional, bool):                      Whether to enable secret rotation. Needs `rotation_lambda_arn`<br/>  - rotation\_lambda\_arn                (optional, string):                    Specifies the ARN of the Lambda function that can rotate the secret. If `null`, the secret will not be rotated.<br/>  - rotation\_schedule\_expression       (optional, string):                    A `cron()` or `rate()` expression that defines the schedule for rotating your secret. Either `automatically_after_days` or `schedule_expression` must be specified. Needs `rotation_lambda_arn`.<br/>  - tags                               (optional, map(string), {}):           Tags specific to the Secrets Manager Secret. Will be merged with `var.tags`. | <pre>object({<br/>    name                               = optional(string, "")<br/>    description                        = optional(string, "")<br/>    use_provided_password              = optional(bool, true)<br/>    username_key                       = optional(string, "username")<br/>    password_key                       = optional(string, "password")<br/>    iam_policy_entity_arns             = optional(map(map(string)), {})<br/>    iam_policy_export_actions          = optional(bool, false)<br/>    iam_policy_identity_export_jsons   = optional(bool, false)<br/>    iam_policy_restrict_by_account_ids = optional(list(string), [])<br/>    iam_policy_restrict_by_regions     = optional(list(string), [])<br/>    iam_policy_sid_prefix              = optional(string, "")<br/>    iam_policy_source_arns             = optional(map(map(string)), {})<br/>    iam_policy_source_policy_documents = optional(list(string), [])<br/>    kms_key_id                         = optional(string)<br/>    kms_key_replica_id                 = optional(string)<br/>    recovery_window_in_days            = optional(number, 7)<br/>    rotation_automatically_after_days  = optional(number)<br/>    rotation_duration                  = optional(number, 24)<br/>    rotation_enabled                   = optional(bool, false)<br/>    rotation_lambda_arn                = optional(string)<br/>    rotation_schedule_expression       = optional(string)<br/>    tags                               = optional(map(string), {})<br/>  })</pre> | `null` | no |
| security\_group | Security Group to create for the database.<br/>If this variable is not set, `var.security_group_ids` is mandatory.<br/>  - name                           (required, string): Name of the security group to create.<br/>  - allowed\_ipv4\_cidrs             (optional, list(string)): CIDRs (ipv4) allowed to communicate to the database.<br/>  - allowed\_ipv6\_cidrs             (optional, list(string)): CIDRs (ipv6) allowed to communicate to the database.<br/>  - allowed\_cidrs\_description      (optional, string): Description of what the CIDRs are for the Security Group rule.<br/>  - allowed\_source\_security\_groups (optional, map(object)):<br/>    - id   (required, string): Id of a source Security Group<br/>    - name (required, string): Corresponding name of the source Security Group<br/>  - tags                           (optional, map(string): Tags for the Security Group created in this module. Will be merged with `var.tags`. | <pre>object({<br/>    name                      = string<br/>    allowed_ipv4_cidrs        = optional(list(string), [])<br/>    allowed_ipv6_cidrs        = optional(list(string), [])<br/>    allowed_cidrs_description = optional(string, "")<br/>    allowed_source_security_groups = optional(map(object({<br/>      id   = optional(string)<br/>      name = optional(string)<br/>    })), {})<br/>    tags = optional(map(string), {})<br/>  })</pre> | `null` | no |
| security\_group\_ids | IDs of the security groups to attach to the RDS instance (or cluster). Additionally, one may create another Security Group through `var.security_group_name`. | `list(string)` | `[]` | no |
| ssm\_parameters\_character\_set\_name\_description | Description of the character set name SSM parameter. | `string` | `"Character set name of the database"` | no |
| ssm\_parameters\_character\_set\_name\_key\_name | Name of the character set name SSM parameter key. | `string` | `"characterSetName"` | no |
| ssm\_parameters\_database\_name\_description | Description of the database name SSM parameter. | `string` | `"Database name created by AWS"` | no |
| ssm\_parameters\_database\_name\_key\_name | Name of the database name SSM parameter key. | `string` | `"databaseName"` | no |
| ssm\_parameters\_endpoint\_description | Description of the endpoint SSM parameter. | `string` | `"DNS address of the database"` | no |
| ssm\_parameters\_endpoint\_key\_name | Name of the endpoint SSM parameter key. | `string` | `"endpoint"` | no |
| ssm\_parameters\_endpoint\_reader\_description | Description of the endpoint reader SSM parameter. | `string` | `"DNS address of the read only RDS cluser"` | no |
| ssm\_parameters\_endpoint\_reader\_key\_name | Name of the endpoint reader SSM parameter key. | `string` | `"endpointReader"` | no |
| ssm\_parameters\_export\_character\_set\_name | Export the character set namein a SSM parameter. If no character set name are provisioned, SSM parameter value will be «N/A» | `bool` | `true` | no |
| ssm\_parameters\_export\_database\_name | Export the database name in a SSM parameter. If no database name are provisioned, SSM parameter value will be «N/A» | `bool` | `true` | no |
| ssm\_parameters\_export\_endpoint | Export the endpoint name in a SSM parameter. | `bool` | `true` | no |
| ssm\_parameters\_export\_endpoint\_reader | Export the endpoint reader name in a SSM parameter. If provisioned engine isn’t aurora, SSM parameter value will be «N/A» | `bool` | `true` | no |
| ssm\_parameters\_export\_master\_password | Export the master password in a secure SSM parameter. | `bool` | `true` | no |
| ssm\_parameters\_export\_master\_username | Export the master username in a secure SSM parameter. | `bool` | `true` | no |
| ssm\_parameters\_export\_port | Export the database port in a SSM parameter. | `bool` | `true` | no |
| ssm\_parameters\_iam\_policy\_create | Create iam policy for SSM parameters and KMS key access. | `bool` | `false` | no |
| ssm\_parameters\_iam\_policy\_name\_prefix\_read\_only | Name of the SSM parameters IAM read only policy. | `string` | `""` | no |
| ssm\_parameters\_iam\_policy\_name\_prefix\_read\_write | Name of the SSM parameters IAM read write policy. | `string` | `""` | no |
| ssm\_parameters\_iam\_policy\_path | Path of the SSM parameters IAM policies. | `string` | `null` | no |
| ssm\_parameters\_kms\_key\_tags | Tags to be merge with all SSM parameters KMS key resources. | `map(string)` | `{}` | no |
| ssm\_parameters\_master\_password\_description | Description of the master passsword SSM parameter. | `string` | `"Master password of the database"` | no |
| ssm\_parameters\_master\_password\_key\_name | Name of the master passsword SSM parameter key. | `string` | `"masterPassword"` | no |
| ssm\_parameters\_master\_username\_description | Description of the master username SSM parameter. | `string` | `"Master username of the database"` | no |
| ssm\_parameters\_master\_username\_key\_name | Name of the master username SSM parameter key. | `string` | `"masterUsername"` | no |
| ssm\_parameters\_port\_description | Description of the database port SSM parameter. | `string` | `"Port of the database"` | no |
| ssm\_parameters\_port\_key\_name | Name of the database port SSM parameter key. | `string` | `"databasePort"` | no |
| ssm\_parameters\_prefix | Prefix to be add on all SSM parameter keys. Cannot started by «/». | `string` | `""` | no |
| ssm\_parameters\_tags | Tags to be merge with all SSM parameters resources. | `map(string)` | `{}` | no |
| tags | Tags to be used in every resources created by this module. | `map(string)` | `{}` | no |
| testing\_prefix | Prefix to be used for all resources names. Specifically useful for tests. A 4-characters alphanumeric string. It must start by a lowercase letter. | `string` | `""` | no |
| vpc\_id | VPC ID where to install the resources of this module. | `string` | `""` | no |

## Outputs

| Name | Description |
|------|-------------|
| aws\_db\_instance | n/a |
| aws\_db\_option\_group | n/a |
| aws\_db\_parameter\_group | n/a |
| aws\_db\_subnet\_group | n/a |
| aws\_kms\_aliases | n/a |
| aws\_kms\_keys | n/a |
| aws\_rds\_cluster | n/a |
| aws\_rds\_cluster\_parameter\_group | n/a |
| aws\_secretsmanager\_secret | n/a |
| aws\_security\_group | n/a |
| precomputed | n/a |
| replica\_aws\_kms\_aliases | n/a |
| replica\_aws\_kms\_keys | n/a |
| secret\_aws\_iam\_policies | n/a |
| secret\_aws\_kms\_alias | n/a |
| secret\_aws\_kms\_key | n/a |
| secret\_replica\_aws\_kms\_alias | n/a |
| secret\_replica\_aws\_kms\_key | n/a |
<!-- END_TF_DOCS -->
